#include <iostream>

template<typename F, typename P> void gf(F f, P p) { // 'gf' generic function
	f(p); // Call of 'f' with 'p' as parameter...
}

void g(void* pointer) {
	std::cout << "'g' function is called...\n";
}

int main(/* int argc, char** argv */) {
	g(NULL); // Fine
	g(0); // This works because 'NULL == 0' from C, but not so fine...

	gf(g, nullptr); // Fine
	// gf(g, NULL); // Compilation error comes from type checking: type of 'NULL' is not 'void*' 

	int i = 0;
	i++;
	int* my_pointer_on_an_int_variable = &i; // Memory address of 'i'
	std::cout << *my_pointer_on_an_int_variable << '\n'; // '1' is displayed...
	int& j = i;
	std::cout << j << '\n'; // '1' is displayed...
	my_pointer_on_an_int_variable = NULL; // '#include &lt;cstddef&gt;' may be omitted to access 'NULL'
	std::cout << *my_pointer_on_an_int_variable << '\n'; // Oops!

	return 0;
}

